//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2022-02-15 13:11:20 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------

using IRaCIS.Core.Application.Helper;
using IRaCIS.Core.Domain.Share;
using Microsoft.AspNetCore.Mvc;
using NPOI.SS.Formula.Functions;
using System.Text.RegularExpressions;

namespace IRaCIS.Core.Application.Contracts
{
    /// <summary>
    /// 系统邮件配置表
    /// </summary>	
    [ApiExplorerSettings(GroupName = "Common")]
    public class EmailNoticeConfigService(IRepository<EmailNoticeConfig> _emailNoticeConfigrepository,
        IRepository<EmailNoticeUserType> _emailNoticeUserTypeRepository, IMapper _mapper, IUserInfo _userInfo, IStringLocalizer _localizer) : BaseService, IEmailNoticeConfigService
    {

        [HttpPost]
        public async Task<PageOutput<EmailNoticeConfigView>> GetEmailNoticeConfigList(EmailNoticeConfigQuery inQuery)
        {
            var emailNoticeConfigQueryable = _emailNoticeConfigrepository
            .WhereIf(inQuery.SystemLevel == null, t => t.SystemLevel == SysEmailLevel.not_sys)
            .WhereIf(inQuery.SystemLevel != null, t => t.SystemLevel == inQuery.SystemLevel)
            .WhereIf(inQuery.IsDistinguishCriteria != null, t => t.IsDistinguishCriteria == inQuery.IsDistinguishCriteria)
             .WhereIf(inQuery.BusinessLevelEnum != null, t => t.BusinessLevelEnum == inQuery.BusinessLevelEnum)
            .WhereIf(inQuery.CriterionTypeEnum != null, t => t.CriterionTypeEnum == inQuery.CriterionTypeEnum)
             .WhereIf(inQuery.BusinessModuleEnum != null, t => t.BusinessModuleEnum == inQuery.BusinessModuleEnum)
            .WhereIf(inQuery.BusinessScenarioEnum != null, t => t.BusinessScenarioEnum == inQuery.BusinessScenarioEnum)
            .WhereIf(inQuery.IsReturnRequired != null, t => t.IsReturnRequired == inQuery.IsReturnRequired)
            .WhereIf(inQuery.IsEnable != null, t => t.IsEnable == inQuery.IsEnable)
             .WhereIf(inQuery.EmailUrgentEnum != null, t => t.EmailUrgentEnum == inQuery.EmailUrgentEnum)
            .WhereIf(inQuery.ToUserType != null, t => t.EmailNoticeUserTypeList.Any(t => t.UserType == inQuery.ToUserType && t.EmailUserType == EmailUserType.To))
            .WhereIf(inQuery.CopyUserType != null, t => t.EmailNoticeUserTypeList.Any(t => t.UserType == inQuery.CopyUserType && t.EmailUserType == EmailUserType.Copy))
            .ProjectTo<EmailNoticeConfigView>(_mapper.ConfigurationProvider);

            return await emailNoticeConfigQueryable.ToPagedListAsync(inQuery);
        }


        public async Task<IResponseOutput> AddOrUpdateEmailNoticeConfig(EmailNoticeConfigAddOrEdit addOrEditEmailNoticeConfig)
        {
            var verifyExp1 = new EntityVerifyExp<EmailNoticeConfig>()
            {
                VerifyExp = t => t.BusinessScenarioEnum == addOrEditEmailNoticeConfig.BusinessScenarioEnum && t.CriterionTypeEnum == addOrEditEmailNoticeConfig.CriterionTypeEnum,

                VerifyMsg = _localizer["EmailNoticeConfig_RepeatEmailScenario"]

            };

            var verifyExp2 = new EntityVerifyExp<EmailNoticeConfig>()
            {
                VerifyExp = t => t.Code == addOrEditEmailNoticeConfig.Code && t.IsDistinguishCriteria == addOrEditEmailNoticeConfig.IsDistinguishCriteria && t.SystemLevel == addOrEditEmailNoticeConfig.SystemLevel,

                VerifyMsg = _localizer["EmailNoticeConfig_RepeatCode"]

            };

            // 匹配所有占位符的正则表达式，允许包含空格的占位符
            var regex = new Regex(@"\{\s*\d+\s*\}");

            if (regex.Matches($"{addOrEditEmailNoticeConfig.EmailTopic}{addOrEditEmailNoticeConfig.EmailTopicCN}{addOrEditEmailNoticeConfig.EmailHtmlContent}{addOrEditEmailNoticeConfig.EmailHtmlContentCN}")
                .Any(t => t.Value.Contains(" ")))
            {
                //邮件模板占位符不允许有空格,请核查占位符的地方
                return ResponseOutput.NotOk(I18n.T("EmailNoticeConfig_ContainEmpty"));
            }




            var entity = new EmailNoticeConfig() { };

            if (addOrEditEmailNoticeConfig.Id == null)
            {

                entity = _mapper.Map<EmailNoticeConfig>(addOrEditEmailNoticeConfig);


                foreach (var item in addOrEditEmailNoticeConfig.ToUserTypeList)
                {
                    entity.EmailNoticeUserTypeList.Add(new EmailNoticeUserType() { EmailUserType = EmailUserType.To, UserType = item });

                }

                foreach (var item in addOrEditEmailNoticeConfig.CopyUserTypeList)
                {
                    entity.EmailNoticeUserTypeList.Add(new EmailNoticeUserType() { EmailUserType = EmailUserType.Copy, UserType = item });

                }


                await _emailNoticeConfigrepository.AddAsync(entity, true, verifyExp1, verifyExp2);


            }
            else
            {
                var emailNoticeConfigId = addOrEditEmailNoticeConfig.Id;
                await _emailNoticeUserTypeRepository.BatchDeleteNoTrackingAsync(t => t.EmailNoticeConfigId == emailNoticeConfigId);


                foreach (var item in addOrEditEmailNoticeConfig.ToUserTypeList)
                {
                    await _emailNoticeUserTypeRepository.AddAsync(new EmailNoticeUserType() { EmailUserType = EmailUserType.To, UserType = item, EmailNoticeConfigId = (Guid)emailNoticeConfigId });

                }

                foreach (var item in addOrEditEmailNoticeConfig.CopyUserTypeList)
                {
                    await _emailNoticeUserTypeRepository.AddAsync(new EmailNoticeUserType() { EmailUserType = EmailUserType.Copy, UserType = item, EmailNoticeConfigId = (Guid)emailNoticeConfigId });

                }


                entity = await _emailNoticeConfigrepository.UpdateFromDTOAsync(addOrEditEmailNoticeConfig, true, false, verifyExp1, verifyExp2);




            }


            if (entity.EmailCron != string.Empty)
            {
                var jobId = $"{entity.Id}_({entity.BusinessScenarioEnum})";

                //有的job 可能编辑控制直接不发，需要移除已存在的
                HangfireJobHelper.RemoveCronJob(jobId);

                if (entity.IsAutoSend && entity.IsEnable)
                {
                    HangfireJobHelper.AddOrUpdateSystemCronJob(jobId, entity.BusinessScenarioEnum, entity.EmailCron);
                }

            }


            return ResponseOutput.Ok(entity.Id.ToString());


        }


        [HttpDelete("{emailNoticeConfigId:guid}")]
        public async Task<IResponseOutput> DeleteEmailNoticeConfig(Guid emailNoticeConfigId)
        {
            var success = await _emailNoticeConfigrepository.BatchDeleteNoTrackingAsync(t => t.Id == emailNoticeConfigId);

            return ResponseOutput.Result(success);
        }



        public async Task<Dictionary<object, string>> GetEmailScenarioEnumSelect()
        {
            return await Task.FromResult(EnumToSelectExtension.ToSelect<EmailScenarioEnum>());
        }
    }
}
