﻿namespace IRaCIS.Application.Contracts
{
    public class AttachmentDTO
    {
        public Guid? Id { get; set; }
        public Guid? DoctorId { get; set; }
        public bool IsOfficial { get; set; }
        public string Type { get; set; } = string.Empty;
        public string Path { get; set; } = string.Empty;
        public string FullPath { get; set; } = string.Empty;
        public string FileName { get; set; } = string.Empty;
        public DateTime? CreateTime { get; set; }

        public DateTime? UpdateTime { get; set; }
        public int Language { get; set; }

        public bool ReUpload { get; set; } = false;

        public Guid? TrialId { get; set; }

        /// <summary>
        /// 是否授权
        /// </summary>

        public bool IsAuthorizedView { get; set; } = false;

        public string BlindName { get; set; } = string.Empty;

        public string BlindNameCN { get; set; } = string.Empty;
        public string ChineseName { get; set; } = string.Empty;
        public string FirstName { get; set; } = string.Empty;
        public string FullName => LastName + " / " + FirstName;
        public string LastName { get; set; } = string.Empty;

        public string UserName { get; set; } = string.Empty;
    }

    public class SetAttachmentAuthorizedView
    {
        public  List<Guid>  Ids { get; set; }

        public bool IsAuthorizedView { get; set; }
    }

    public class DeleteAttachment
    {
        public List<Guid> Ids { get; set; }
    }

    public class GetTrialDoctorSelectInDto
    {
        public Guid TrialId { get; set; }
    }

    public class GetTrialDoctorListOutDto
    {
        public Guid Id { get; set; }
        public string BlindName { get; set; } = string.Empty;

        public string BlindNameCN { get; set; } = string.Empty;
        public string ChineseName { get; set; } = string.Empty;
        public string FirstName { get; set; } = string.Empty;
        public string FullName => LastName + " / " + FirstName;
        public string LastName { get; set; } = string.Empty;
    }

    public class GetTrialAttachmentsInDto:PageInput
    {
        public Guid TrialId { get; set; }

        public string? Type { get; set; }

        public Guid? DoctorId { get; set; }

        public string? FileName { get; set; }

        public bool? IsAuthorizedView { get; set; }
    }
    public class ReviewerAckDTO
    {
        public Guid Id { get; set; }
        public Guid DoctorId { get; set; }
        public string Type { get; set; } = string.Empty;
        public string Path { get; set; } = string.Empty;
        public string FullPath => Path;
        public string FileName { get; set; } = string.Empty;
    }





    public class TrialSOWPathDTO
    {
        public Guid TrialId { get; set; }

        public string SowName { get; set; } = string.Empty;
        public string SowPath { get; set; } = string.Empty;
    }

    public class DeleteSowPathDTO
    {
        public Guid TrialId { get; set; }
        public string Path { get; set; } = string.Empty;

    }

    public class UploadAgreementAttachmentDTO
    {
        public Guid Id { get; set; }

        public Guid DoctorId { get; set; }
        public string Type { get; set; } = string.Empty;
        public string Path { get; set; } = string.Empty;
        public string FullPath => Path;

        public string FileName { get; set; } = string.Empty;
    }

    public class AttachementCommand
    {
        public Guid Id { get; set; }
        public string Path { get; set; } = string.Empty;
    }
}
