﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class SVImageBack : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AlterColumn<int>(
                name: "RequestBackState",
                table: "SubjectVisit",
                type: "int",
                nullable: false,
                comment: "一致性核查 回退",
                oldClrType: typeof(int),
                oldType: "int");

            migrationBuilder.AddColumn<int>(
                name: "ImageBackState",
                table: "SubjectVisit",
                type: "int",
                nullable: false,
                defaultValue: 0,
                comment: "影像上传 回退");

            migrationBuilder.CreateIndex(
                name: "IX_EnrollReadingCriterion_TrialReadingCriterionId",
                table: "EnrollReadingCriterion",
                column: "TrialReadingCriterionId");

            migrationBuilder.CreateIndex(
                name: "IX_EnrollReadingCategory_TrialReadingCriterionId",
                table: "EnrollReadingCategory",
                column: "TrialReadingCriterionId");

            migrationBuilder.CreateIndex(
                name: "IX_DoctorCriterionFile_TrialReadingCriterionId",
                table: "DoctorCriterionFile",
                column: "TrialReadingCriterionId");

            migrationBuilder.AddForeignKey(
                name: "FK_DoctorCriterionFile_ReadingQuestionCriterionTrial_TrialReadingCriterionId",
                table: "DoctorCriterionFile",
                column: "TrialReadingCriterionId",
                principalTable: "ReadingQuestionCriterionTrial",
                principalColumn: "Id");

            migrationBuilder.AddForeignKey(
                name: "FK_EnrollReadingCategory_ReadingQuestionCriterionTrial_TrialReadingCriterionId",
                table: "EnrollReadingCategory",
                column: "TrialReadingCriterionId",
                principalTable: "ReadingQuestionCriterionTrial",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_EnrollReadingCriterion_ReadingQuestionCriterionTrial_TrialReadingCriterionId",
                table: "EnrollReadingCriterion",
                column: "TrialReadingCriterionId",
                principalTable: "ReadingQuestionCriterionTrial",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_DoctorCriterionFile_ReadingQuestionCriterionTrial_TrialReadingCriterionId",
                table: "DoctorCriterionFile");

            migrationBuilder.DropForeignKey(
                name: "FK_EnrollReadingCategory_ReadingQuestionCriterionTrial_TrialReadingCriterionId",
                table: "EnrollReadingCategory");

            migrationBuilder.DropForeignKey(
                name: "FK_EnrollReadingCriterion_ReadingQuestionCriterionTrial_TrialReadingCriterionId",
                table: "EnrollReadingCriterion");

            migrationBuilder.DropIndex(
                name: "IX_EnrollReadingCriterion_TrialReadingCriterionId",
                table: "EnrollReadingCriterion");

            migrationBuilder.DropIndex(
                name: "IX_EnrollReadingCategory_TrialReadingCriterionId",
                table: "EnrollReadingCategory");

            migrationBuilder.DropIndex(
                name: "IX_DoctorCriterionFile_TrialReadingCriterionId",
                table: "DoctorCriterionFile");

            migrationBuilder.DropColumn(
                name: "ImageBackState",
                table: "SubjectVisit");

            migrationBuilder.AlterColumn<int>(
                name: "RequestBackState",
                table: "SubjectVisit",
                type: "int",
                nullable: false,
                oldClrType: typeof(int),
                oldType: "int",
                oldComment: "一致性核查 回退");
        }
    }
}
